/************************************************************************/
/*

    Output class.  Gets blocks of sorted numbers from the analysis class
    and writes them to tape.

*/
/************************************************************************/

#include <stdio.h>
#include "rnd.h"

#define NBUF 3

main() {

    int i,p1,p2;

    FILE *fp,*fopen();

    int bp = 0;                         /* Buffer pointer */
    float x[NBUF][EVENT_SIZE];
    int flag[NBUF];
    int process[NBUF];
    int bcount[NBUF];
    int qnum;

    int p;

    int byte_count,blockno,offset;

    int n;
    int eventno = 0;

    int eoq = 0;

    cps_init();

    fp = fopen("sorted.numbers","w");
    if (fp == NULL) {
	printf("failed to open output tape\n");
	fflush(stdout);
	cps_stop_job();
    }

    for (i=0; i<NBUF; i++) flag[i] = 0;

    p1 = CPS_ALL_PROCESSES;
    p2 = BEGIN_SYNC;
    cps_sync(&p1,&p2);

    while (1) {

/* Initiate any possible asynchronous dequeues and gets */

	if (!eoq) {
	  for (i=0; i<NBUF; i++) {
	    if (flag[i] == 0) {
		byte_count = OUT_SIZE * sizeof(float);
		blockno = OUT_BLOCK;
		flag[i] = 1;
		cps_queue_xfer(&x[i][0],&byte_count,&blockno,
			&flag[i],&bcount[i]);
		qnum = DONE_QUEUE;
		cps_dq_get(&qnum,&process[i]);
	    }
	  }
	}

/* Write out any events received and re-queue */

	for (i=0; i<NBUF; i++) {
	    if (flag[i] == -1) {
		if (process[i] != CPS_END_OF_QUEUE) {
		    eventno++;
		    if ((eventno % 10) == 0) {
			printf("Event %d written (%d bytes)\n",eventno,
				bcount[i]);
			fflush(stdout);
		    }
		    fwrite(&x[i][0],4,bcount[i]/4,fp);
		}
		else {
		    printf("Got end of queue, slot=%d\n",i);
		    fflush(stdout);
		    eoq = -1;
		}
		flag[i] = 0;
		qnum = READY_QUEUE;
		cps_queue_process(&process[i],&qnum);
	    }
	}

/* Check for the end of job condition (all flags become -1 or 0) */

	if (eoq) {
	    for (i=0; i<NBUF; i++) {
		if (flag[i] == 1) goto label1;
	    }
	    fclose(fp);
	    cps_stop_job();
	}

/* Sleep for a second (will be interrupted by any background activity) */

	label1:
	sleep(1);

    }
}
