/*

 Name  :        fgtched.h
 Descr :        Header file for cps test programs (all modes)

 Author:	R. C. Yeager
		Fermi National Accelerator Laboratory - Mail Station 369
		P.O Box 500
		Batavia, IL 60510

 Copyright (c) 1992 Universities Research Association, Inc.        
       All Rights Reserved                                                    


 This material resulted from work developed under a Government Contract and   
 is subject to the following license:  The Government retains a paid-up,      
 nonexclusive, irrevocable worldwide license to reproduce, prepare derivative 
 works, perform publicly and display publicly by or for the Government,       
 including the right to distribute to other Government contractors.  Neither  
 the United States nor the United States Department of Energy, nor any of     
 their employees, makes any warrenty, express or implied, or assumes any      
 legal liability or responsibility for the accuracy, completeness, or         
 usefulness of any information, apparatus, product, or process disclosed, or  
 represents that its use would not infringe privately owned rights.

*/

#include <cps_user.h>
#include <math.h>


#define MAX_HEADER_SIZE	80
#define NUM_OF_HEAD	6

#define DEBUG_TEST1IN	TRUE
#define DEBUG_TEST1ANA	TRUE
#define DEBUG_TEST1OUT	TRUE

#define HEADR struct headr
HEADR {
	char	header_ini[MAX_HEADER_SIZE];
	char	header_ino[MAX_HEADER_SIZE];
	char	header_ani[MAX_HEADER_SIZE];
	char	header_ano[MAX_HEADER_SIZE];
	char	header_oti[MAX_HEADER_SIZE];
	char	header_oto[MAX_HEADER_SIZE];
        int     block[1];
} ;

#define IDEV "none"
#define ODEV "none"
#define IFILE "no"
#define OFILE "no"
#define MSGNUM 10001
#define MSGINC 100
#define MSGISIZE 32000
#define MSGOSIZE 32000
#define NBUF 16

/* Process classes */

#define INPUT 1
#define ANALYSIS 2
#define OUTPUT 3

/* Process queues */

#define READY_QUEUE 1
#define DONE_QUEUE 2

/* Synch points */

#define BEGIN_SYNC 0
#define END_SYNC 1

/* Remote subroutines */

#define ANALYSIS_REMSUB 1

/* Data blocks */

#define IN_BLOCK 1
#define OUT_BLOCK 2
#define NOT_BLOCK 3

