/*

 Name  :        fgtcah.c
 Descr :        Event analysis program for cps high level asynch mode test job

 Author:	R. C. Yeager
		Fermi National Accelerator Laboratory - Mail Station 369
		P.O Box 500
		Batavia, IL 60510

 Copyright (c) 1992 Universities Research Association, Inc.        
       All Rights Reserved                                                    


 This material resulted from work developed under a Government Contract and   
 is subject to the following license:  The Government retains a paid-up,      
 nonexclusive, irrevocable worldwide license to reproduce, prepare derivative 
 works, perform publicly and display publicly by or for the Government,       
 including the right to distribute to other Government contractors.  Neither  
 the United States nor the United States Department of Energy, nor any of     
 their employees, makes any warrenty, express or implied, or assumes any      
 legal liability or responsibility for the accuracy, completeness, or         
 usefulness of any information, apparatus, product, or process disclosed, or  
 represents that its use would not infringe privately owned rights.

*/



#include <stdio.h>
#include <acp_user.h>
#include "fgtched.h"

main() 

    {

    void gtimfunc();                    /* declare the time function         */

    int sub;                            /* general subscript variable        */
    int max_imsg_size;                  /* input block size from getenv      */
    int max_omsg_size;                  /* output block size from getenv     */
    int block_size;                     /* cps input block size variable     */
    int num_elem;                       /* number of ints in input block     */ 
    int extra_size;                     /* cps output block size variable    */
    int extra_elem;                     /* number of ints in output block    */ 
    int copy_block_size;                /* input block size to copy          */ 
    int which_proc;                     /* cps process number                */
    int act_type;                       /* cps requested action type         */
    int block_no;                       /* cps block id (queue number)       */
    int proc_num;                       /* cps returned process id variable  */
    int queue_num;                      /* cps declare queue id variable     */
    int nq_args;                        /* cps number of queue arguments var */
    int nblocks;                        /* acp_wait_for_data number of blocks*/
    int blocklist[1];                   /* acp_wait_for_data block id array  */

    char obuf[8];                       /* returned value from time function */
    HEADR *buffin;                      /* data buff ptr cast w/HEADR struct */
    HEADR *buffot;                      /* data buff ptr cast w/HEADR struct */

    acp_init();

    gtimfunc(obuf);
    printf("Starting  : Time %.8s\n",obuf);
    fflush(stdout);

    max_imsg_size = MSGISIZE;
    max_omsg_size = MSGOSIZE;
    buffin = (HEADR *) malloc(max_imsg_size);
    buffot = (HEADR *) malloc(max_omsg_size);

    if (max_omsg_size > max_imsg_size)
        {
        num_elem = (max_imsg_size/sizeof(int));
        extra_size = (max_omsg_size-max_imsg_size);
        extra_elem = (extra_size/sizeof(int));
        for (sub = num_elem; sub < extra_elem; sub++)
            {
            buffot->block[sub] = rand();
            }
        copy_block_size = max_imsg_size;
        }
    else
        {
        copy_block_size = max_omsg_size;
        }
 
    block_size = max_imsg_size; 
    block_no = IN_BLOCK;
    acp_declare_block(buffin,&block_size,&block_no);

    block_size = max_omsg_size;
    block_no = OUT_BLOCK;
    acp_declare_block(buffot,&block_size,&block_no);

    queue_num = READY_QUEUE;
    nq_args = 0;
    acp_declare_queue(&queue_num,&nq_args);

    queue_num = DONE_QUEUE;
    nq_args = 0;
    acp_declare_queue(&queue_num,&nq_args);

    which_proc = ACP_THIS_PROCESS;
    act_type = READY_QUEUE;
    acp_queue_process(&which_proc,&act_type);

    which_proc = ACP_ALL_PROCESSES;
    act_type = BEGIN_SYNC;
    acp_sync(&which_proc,&act_type);

    gtimfunc(obuf);
    printf("Synchd    : Time %.8s\n",obuf);
    fflush(stdout);

    /* comments */

    while (1) 
    
        {

        int i,j,num;
        float f,sum;

        nblocks = 1;
        blocklist[0] = IN_BLOCK;
        acp_wait_for_data(&nblocks,blocklist);

        gtimfunc(obuf);
        acp_process_number(&proc_num);
        sprintf(buffin->header_ani, 
            "From Input: Time %.8s Proc num %d", 
            obuf,proc_num);
 /*
        for (i=0; i < MAX_I_ELEMENTS; i++) 
            {
            for (j=0; j < msg.block[i]; j++) 
                {
                f = j;
                sum = sqrt(abs(f)); 
                if (sum > 1000000.0) sum = 0;
                }
            }
 */


        bcopy(&buffin[0],&buffot[0],copy_block_size);  /* move in to out     */ 
        buffot->block[0] = max_omsg_size;

        gtimfunc(obuf);
        sprintf(buffot->header_ano, 
            "To Output : Time %.8s Proc num %d", 
            obuf,proc_num);

        block_no = OUT_BLOCK;
        block_size = max_omsg_size;
        acp_data_ready(&block_no,&block_size);
        
        which_proc = ACP_THIS_PROCESS;
        queue_num = DONE_QUEUE;
        acp_queue_process(&which_proc,&queue_num);

        }                               /* end of while block                */

    }                                   /* end of main block                 */

    /*  called function to format and return the time in format HH:MM:SS     */

    void gtimfunc(obuf) 

        {
        
        long tloc;                      /* return variable from time function*/
        char buf[30];                   /* formatted time variable           */
 
        time(&tloc);                    /* get current time                  */
        strcpy(buf,ctime(&tloc));       /* format current time into buf      */
        strncpy(obuf,&buf[11],8);       /* move time value to obuf           */
        return;                         /* return to caller                  */

        }
