/*

 Author:	Matt Fausey
		Fermi National Accelerator Laboratory - Mail Station 369
		P.O Box 500
		Batavia, IL 60510
		DECnet: FNAL::FAUSEY
		Internet: fausey@fnsgia.fnal.gov

 Copyright (c) 1991 Universities Research Association, Inc.        
       All Rights Reserved                                                    


 This material resulted from work developed under a Government Contract and   
 is subject to the following license:  The Government retains a paid-up,      
 nonexclusive, irrevocable worldwide license to reproduce, prepare derivative 
 works, perform publicly and display publicly by or for the Government,       
 including the right to distribute to other Government contractors.  Neither  
 the United States nor the United States Department of Energy, nor any of     
 their employees, makes any warrenty, express or implied, or assumes any      
 legal liability or responsibility for the accuracy, completeness, or         
 usefulness of any information, apparatus, product, or process disclosed, or  
 represents that its use would not infringe privately owned rights.

*/

/*

    Source File: cps_msg_rt.h

    Explanation: Frequently called message building/decoding routines made into
		 macros.

*/


#define SET_LPN(m,x,y) m->src_lpn = (long) x; \
                       m->dst_lpn = (long) y;

#define STRCPY(s1,s2) if (strlen(s2) < 256)     \
                          strcpy(s1,s2);        \
                      else {                    \
                          bcopy(s2,s1,255);     \
                          s1[255] = '\0';       \
                      }

#define cps_bld_fill_buffer(M,S,D,INDEX,XFER_TYPE,VADDR,BLOCKNO,OFFSET,SIZE) \
{						\
    long *x;					\
						\
    SET_LPN(M,S,D)				\
    M->type = (long) MSG_FILL_BUFFER;		\
    x = (long *) M->msg;			\
    *x = (long) INDEX;				\
    x++;					\
    *x = (long) XFER_TYPE;			\
    x++;					\
    *x = (long) VADDR;				\
    x++;					\
    *x = (long) BLOCKNO;			\
    x++;					\
    *x = (long) OFFSET;				\
    x++;					\
    *x = (long) SIZE;				\
    M->size = (long) 6*sizeof(long);		\
}

#define cps_bld_data_ack(M,S,D,INDEX)	\
{					\
    long *x;				\
					\
    SET_LPN(M,S,D)			\
    M->type = (long) MSG_DATA_ACK;	\
    x = (long *) M->msg;		\
    *x = (long) INDEX;			\
    M->size = (long) sizeof(long);	\
}
