/*

 Author:	Matt Fausey
		Fermi National Accelerator Laboratory - Mail Station 369
		P.O Box 500
		Batavia, IL 60510
		DECnet: FNAL::FAUSEY
		Internet: fausey@fnsgia.fnal.gov

 Copyright (c) 1990 Universities Research Association, Inc.        
       All Rights Reserved                                                    


 This material resulted from work developed under a Government Contract and   
 is subject to the following license:  The Government retains a paid-up,      
 nonexclusive, irrevocable worldwide license to reproduce, prepare derivative 
 works, perform publicly and display publicly by or for the Government,       
 including the right to distribute to other Government contractors.  Neither  
 the United States nor the United States Department of Energy, nor any of     
 their employees, makes any warrenty, express or implied, or assumes any      
 legal liability or responsibility for the accuracy, completeness, or         
 usefulness of any information, apparatus, product, or process disclosed, or  
 represents that its use would not infringe privately owned rights.

*/



/* Database Utility Routine Declarations */

extern struct cpu_list *find_cpu();
extern struct cpu_list *add_cpu();
extern struct tape_drive_list *find_tape();
extern struct tape_drive_list *find_phys_tape();
extern struct tape_drive_list *add_tape();
extern struct prod_sys *find_prodsys();
extern struct prod_sys *add_prodsys();
extern struct tape_drive_list *clear_tape_list();
extern struct cpu_list *clear_cpu_list();
extern struct prod_sys *clear_production_systems();
extern struct prod_cpu_list *cpu_in_prodsys();
extern struct prod_tape_list *tape_in_prodsys();
extern char *build_query_msg();
extern char *build_update_msg();
extern struct prod_job_list *create_job_record();
extern struct class_list *add_class();
extern struct tape_list_head *add_tape_list();
extern struct class_list *find_class();
extern struct tape_list_head *find_tape_list();
extern struct word_list *add_word_to_list();
extern struct word_list *find_word();
extern struct prod_job_list *find_job();
extern struct ordered_tape_list *find_tape_reel();
extern char *cpu_alias();
extern struct cpu_list *find_cpu_alias();
extern struct fs_list *find_fs();
extern struct prod_cpu_list *find_cpu_in_prod();
extern struct pm_list *randomize_pm_list();
extern struct prod_job_list *extract_from_queue();
