/*

 Author:	Matt Fausey
		Fermi National Accelerator Laboratory - Mail Station 369
		P.O Box 500
		Batavia, IL 60510
		DECnet: FNAL::FAUSEY
		Internet: fausey@fnsgia.fnal.gov

 Copyright (c) 1990 Universities Research Association, Inc.        
       All Rights Reserved                                                    


 This material resulted from work developed under a Government Contract and   
 is subject to the following license:  The Government retains a paid-up,      
 nonexclusive, irrevocable worldwide license to reproduce, prepare derivative 
 works, perform publicly and display publicly by or for the Government,       
 including the right to distribute to other Government contractors.  Neither  
 the United States nor the United States Department of Energy, nor any of     
 their employees, makes any warrenty, express or implied, or assumes any      
 legal liability or responsibility for the accuracy, completeness, or         
 usefulness of any information, apparatus, product, or process disclosed, or  
 represents that its use would not infringe privately owned rights.

*/


/********************************/
/* Job Manager Global Variables */
/********************************/

char *job_name = NULL;
char *jdf_file = NULL;
char *log_file = NULL;
char *abort_file = NULL;
char *jm_hostname = NULL;
long jm_starttime;

int login_prompt = 0;
int log_level = 2;
int term_level = 2;
int dbg_level = 0;

int batch_mode = 0;
char *p_system = NULL;

int carbon_copy = 0;
int invoke_cpp = 0;

int pm_connect_flag = 0;

int user_timeout = 15;

char cpp_options[256];

int netrc_exists = 0;
char login_name[24];
char password[24];

char tty_name[64];

int rexec_port;

FILE *jml;

extern char local_hostname[64];
extern char local_hostaddr[24];
extern int assigned_port_number;

extern char *msg_cmd,**msg_args;

/* CPU information */

int num_sdf_cpus = 0;
struct cpu_info sdf_cpu[MAX_SDF_CPUS];


/* Class information */

struct class_info class[MAX_CLASSES+1];	


/* Process information */

int num_shm_procs = 0;		
int num_usr_procs = 0;
struct shm_map shm_map[MAX_SHM_PROCESSES];
struct user_map usr_map[MAX_PROCESSES];


/* Queue Information */

struct cps_msg_queue *zfree;
struct queue_info jmq[MAX_QUEUES];


/* Sync Information */

int sync_active[MAX_SYNCS];
unsigned long *need_sync[MAX_SYNCS];	/* Set of proc needed to satisfy sync */
unsigned long *at_sync[MAX_SYNCS];	/* Set of procs at sync point */
int proc_sync[MAX_PROCESSES];		/* Sync pt each proc is at, -1 = none*/


/* User Status Information */

int user_status[MAX_PROCESSES][MAX_USER_STATUS];


/* Remote Subroutine Information */

struct acp_remote_sub *remote_subs = NULL;


/* Data Block Information */

struct acp_data_rdy *acp_dblocks[MAX_PROCESSES];


/* Monitor shared memory */

int mon_shmid;
struct cps_job_stats *mon_shm;

/* jmdb */
char jm_pause = 0;
char jm_step  = 0;
char jm_prof  = 0;
char jm_init  = 0;
char sync_stop[ MAX_SYNCS ];
char queue_stop[ MAX_QUEUES ];
char user_stop[ MAX_USER_HOOKS ];
char proc_stop[ MAX_FUNC_HOOKS ];
int sync_point = -1;
int queue_point = -1;
int user_point = -1;
int proc_point = -1;
char upshot = 0;
char jm_hooks = 0;
char alarm_occured = 0;
