/*

 Author:	Roberto Ullfig
			Fermi National Accelerator Laboratory - Mail Station 369
			P.O Box 500
			Batavia, IL 60510
			DECnet: FNAL::ULLFIG
			Internet: ullfig@fnrobo.fnal.gov

			Copyright (c) 1993 Universities Research Association, Inc.
			All Rights Reserved 


 This material resulted from work developed under a Government Contract and   
 is subject to the following license:  The Government retains a paid-up,	  
 nonexclusive, irrevocable worldwide license to reproduce, prepare derivative 
 works, perform publicly and display publicly by or for the Government,	   
 including the right to distribute to other Government contractors.  Neither  
 the United States nor the United States Department of Energy, nor any of	 
 their employees, makes any warrenty, express or implied, or assumes any	  
 legal liability or responsibility for the accuracy, completeness, or
 usefulness of any information, apparatus, product, or process disclosed, or  
 represents that its use would not infringe privately owned rights.

*/

#include <unistd.h>
#include <errno.h>

handle_pwd()
{
	char *cwd;

	if( ( cwd = getcwd( (char *)NULL, 64 ) ) == NULL )
	{
		perror("pwd");
		return;
	}
	printf("%s\n",cwd);

	free( cwd );
}

handle_cd( dir )
char *dir;
{
	if( chdir( dir ) )
		printf("%s: %s\n",dir,strerror(errno));
}

handle_ls()
{
	char string[128];

	sprintf( string, "%s", "/bin/ls" );

	if( system( string ) < 0 )
		perror("ls");
}

handle_sh( command )
char *command;
{
	char string[128];
	char *shell = (char *)getenv("SHELL");

	if( strlen( command ) != 3 )
	{
		handle_shell( command );
		return;
	}

	if( shell == NULL )
		sprintf( string, "%s", "/bin/csh" );
	else
		sprintf( string, "%s", shell );

	if( system( string ) < 0 )
		perror("sh");

	printf("\n");
}

handle_shell( command )
char *command;
{
	char string[128];

	sprintf( string, "%s", &command[2] );
	if( system( string ) < 0 )
		perror("shell");

	printf("\n");
}

mail_to_user( user, message )
char *user;
char *message;
{
	char string[1024];

	sprintf( string, "echo %s | mail %s", message, user );
	if( system( string ) < 0 )
		perror("mail");
}
