
#define CALLBACK	1
#define END_OF_JOB	2

#include "../inc/types.h"
#include "../inc/time.h"
#include <stdio.h>
#include <signal.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <errno.h>
#include <rpc/rpc.h>
#include "jm_rpc.h"

/* Default timeout can be changed using clnt_control() */
static struct timeval TIMEOUT = { 25, 0 };

CLIENT *client = NULL;
unsigned interval;
char callback_initiated = 0;

callback_status( sig, code, sc )
int sig, code;
struct sigcontext *sc;
{
	if( callback_initiated )
	{
		clnt_call( client, CALLBACK, xdr_void, 0, xdr_void, 0, TIMEOUT );
		alarm( interval );
	}
}

callback_endjob()
{
	if( callback_initiated )
	{
		clnt_call( client, END_OF_JOB, xdr_void, 0, xdr_void, 0, TIMEOUT );
		clnt_destroy( client );
	}
}

char
*rpc_initiate_callback_1( caller )
struct client_info *caller;
{
	static char reply;
	struct sockaddr_in addr;
	struct hostent *hp;
	int sock = RPC_ANYSOCK;

	hp = gethostbyname( caller->hostname );
	if( hp == NULL )
	{
		fprintf( stderr, "%s:%s\n", caller->hostname, strerror( errno ) );
		reply = 0;
		return( &reply );
	}
	bcopy( hp->h_addr, &addr.sin_addr, hp->h_length );
	addr.sin_family = AF_INET;
	addr.sin_port = 0;

	if( callback_initiated )
	{
		reply = 0;
		return( &reply );
	}

	if( sig_establish_handler( SIGALRM, callback_status ) )
	{
		reply = 0;
	}
	else
	{
		/* client = clnt_create( caller->hostname, caller->prognum,
			caller->vers, "tcp" ); */
		client = clnttcp_create( &addr, caller->prognum, caller->vers,
			&sock, 0, 0 );
		if( client == NULL )
		{
			reply = 0;
			sig_establish_handler( SIGALRM, SIG_DFL );
		}
		else
		{
			reply = 1;
			callback_initiated = 1;
			interval = (unsigned)caller->interval;
			alarm( interval );
		}
	}

	return( &reply );
}

char
*rpc_terminate_callback_1()
{
	static char reply;

	if( callback_initiated )
	{
		alarm( 0 );
		clnt_destroy( client );
		sig_establish_handler( SIGALRM, SIG_DFL );
		callback_initiated = 0;
		reply = 1;
	}
	else
	{
		reply = 0;
	}

	return( &reply );
}
