/*

 Author:	Roberto Ullfig
		Fermi National Accelerator Laboratory - Mail Station 369
		P.O Box 500
		Batavia, IL 60510
		DECnet: FNAL:ULLFIG
		Internet: ullfig@fnrobo.fnal.gov

 Copyright (c) 1990 Universities Research Association, Inc.	    
	   All Rights Reserved                                                    


 This material resulted from work developed under a Government Contract and   
 is subject to the following license:  The Government retains a paid-up,	  
 nonexclusive, irrevocable worldwide license to reproduce, prepare derivative 
 works, perform publicly and display publicly by or for the Government,	   
 including the right to distribute to other Government contractors.  Neither  
 the United States nor the United States Department of Energy, nor any of	 
 their employees, makes any warrenty, express or implied, or assumes any	  
 legal liability or responsibility for the accuracy, completeness, or	     
 usefulness of any information, apparatus, product, or process disclosed, or  
 represents that its use would not infringe privately owned rights.

*/
typedef struct element *int_array;

struct element
{
	char lpn;
	int_array next;
};

union int_array_res
switch( int errno )
{
	case 0:
		int_array plist;
	default:
		void;
};

struct int_pair
{
	int x;
	int y;
};

struct client_info
{
	int prognum;
	int vers;
	int interval;
	char hostname[64];
};

struct rpc_message
{
	long type;
	long src_lpn;
	long dst_lpn;
	long size;
	char msg[16];
};

program JMPROG
{
	version JMVERS
	{
		int RPC_GET_USER_STATUS( int_pair ) = 1;
		int RPC_GET_CALL_COUNT( int_pair ) = 2;
		int RPC_GET_PROCESS_STATE( int ) = 3;
		int RPC_GET_PROCESS_ATTRIBUTES( int ) = 4;
		int RPC_GET_NSENDS( int ) = 5;
		int	RPC_GET_SNDCUR( int ) = 6;
		int	RPC_GET_SNDAVG( int ) = 7;
		int	RPC_GET_NGETS( int ) = 8;
		int	RPC_GET_GETCUR( int ) = 9;
		int	RPC_GET_GETAVG( int ) = 10;
		int	RPC_GET_Q_DECLARED( int ) = 11;
		int	RPC_GET_Q_SET( int ) = 12;
		int	RPC_GET_JOB_DONE( void ) = 13;
		int	RPC_GET_NUM_PROC( void ) = 14;
		int	RPC_GET_PROCESS_CLASS( int ) = 15;
		int	RPC_GET_NDQ_SET( int ) = 16;

		char RPC_KILL_JM( void ) = 20;
		char RPC_STEP_JM( void ) = 21;
		char RPC_STOP_JM( void ) = 22;
		char RPC_CONTINUE_JM( void ) = 23;

		char RPC_GET_JM_STATUS( void ) = 30;
		int	RPC_GET_JM_PID( void ) = 31;
		string RPC_GET_JM_DIRECTORY( void ) = 32;
		string RPC_GET_JM_VERSION( void ) = 33;
		string RPC_GET_JM_USERNAME( void ) = 34;
		rpc_message RPC_GET_JM_MESSAGE( void ) = 35;
		string RPC_GET_JOB_NAME( void ) = 36;
		long RPC_GET_JM_STARTTIME( void ) = 37;

		int    RPC_GET_PROCESS_ID( int ) = 40;
		string RPC_GET_PROCESS_HOST( int ) = 41;
		string RPC_GET_PROCESS_NAME( int ) = 42;
		string RPC_GET_PROCESS_DIR( int ) = 43;
		string RPC_GET_LOG_FILE( void ) = 44;

		char RPC_UPSHOT_SWITCH( int ) = 50;
		char RPC_HOOK_SWITCH( int ) = 51;

		int_array_res RPC_GET_PROCESS_QUEUE( int ) = 60;
		int_array_res RPC_GET_AT_SYNC( int ) = 61;
		int_array_res RPC_GET_NEED_SYNC( int ) = 62;

		char RPC_STOP_AT_BRKPT( int_pair ) = 70;
		char RPC_CONT_AT_BRKPT( int_pair ) = 71;
		int_pair RPC_GET_LOCATION( void ) = 72;
		int_array_res RPC_GET_BREAKPOINTS( int ) = 73;

		char RPC_INITIATE_CALLBACK( client_info ) = 100;
		char RPC_TERMINATE_CALLBACK( void ) = 101;

	} = 1;
} = 0x20000001;
