/*

 Author:	Matt Fausey
		Fermi National Accelerator Laboratory - Mail Station 369
		P.O Box 500
		Batavia, IL 60510
		DECnet: FNAL::FAUSEY
		Internet: fausey@fnsgia.fnal.gov

 Copyright (c) 1990 Universities Research Association, Inc.        
       All Rights Reserved                                                    


 This material resulted from work developed under a Government Contract and   
 is subject to the following license:  The Government retains a paid-up,      
 nonexclusive, irrevocable worldwide license to reproduce, prepare derivative 
 works, perform publicly and display publicly by or for the Government,       
 including the right to distribute to other Government contractors.  Neither  
 the United States nor the United States Department of Energy, nor any of     
 their employees, makes any warrenty, express or implied, or assumes any      
 legal liability or responsibility for the accuracy, completeness, or         
 usefulness of any information, apparatus, product, or process disclosed, or  
 represents that its use would not infringe privately owned rights.

*/


#include <stdio.h>

str_toupper(s)

char *s;
{
	while ((*s = toupper(*s)) != '\0') s++;
}

str_tolower(s)

char *s;
{
	while ((*s = tolower(*s)) != '\0') s++;
}


char *skip_spaces(s)
char *s;
{
	while(*s == ' ') s++;
	return(s);
}


char *next_word(s)
char *s;
{

	/* find next space or end of string */

	while(*s != ' ' && *s != '\0' && *s != '\n') s++;

	/*  replace with \0 */

	if (*s != '\0') {
		*s = '\0';
		s++;
	}
	return(s);
}


char *hms(seconds)	/* returns a string of hours, minutes and seconds */
float seconds;
{
	static char hms1[10];

	int hours,minutes,sec;

	hours = seconds/3600.0;
	seconds -= (float)hours*3600.0;
	minutes = seconds/60.0;
	seconds -= (float)minutes*60.0;
	sec = seconds;

	sprintf(hms1,"%d:%02d:%02d",hours,minutes,sec);

	return(hms1);
}

char *minsec(seconds)	/* returns a string of minutes and seconds */
float seconds;
{
	static char minsec1[10];

	int minutes,sec;

	minutes = seconds/60.0;
	seconds -= (float)minutes*60.0;
	sec = seconds;

	sprintf(minsec1,"%d:%02d",minutes,sec);
	return(minsec1);
}


str_f_to_c(fstr,flen,cstr,clen)
char *fstr,*cstr;
int flen,clen;
{
	int n;

	n = flen < clen ? flen : clen;
	strncpy(cstr,fstr,n);
	cstr[n-1] = '\0';
}


str_switch(str,c1,c2)
char *str,c1,c2;
{
	char *c,*strchr();

	while (1) {
		c = strchr(str,c1);
		if (c == NULL) break;
		*c = c2;
	}
}

int str_find(str,strings,max_n)
char *strings[],*str;
int max_n;
{
	int i;

	for (i=0; i<max_n; i++) {
		if (strcmp(str,strings[i]) == 0) return i;
	}
	return -1;
}


static char formatted_str[256];
static int eos = 0;				/* End of string */

int init_formatted_str() {
	int i;
	for (i=0; i<256; i++) formatted_str[i] = ' ';
	formatted_str[0] = '\0';
	eos = 0;
}

int add_formatted(p,str)
int p;
char *str;
{
	if (p == -1) return;
	sprintf(&formatted_str[p],"%s",str);
	if ((p + strlen(str)) > eos) {
		if (formatted_str[eos] == '\0') formatted_str[eos] = ' ';
		eos = p + strlen(str);
	}
	else {
		formatted_str[p+strlen(str)] = ' ';
	}
}

char *get_formatted() {
	return formatted_str;
}


char *simple_hostname(hostname)
char *hostname;
{
	static char s[80];

	char *c,*strchr();

	c = strchr(hostname,'.');
	if (c == NULL) return hostname;

	strcpy(s,hostname);
	c = strchr(s,'.');
	*c = '\0';
	return s;
}
