/*
**
** Demo program:
** 
** Uses the exponential map method to 
** integrate z' = z.
** 
** --- Leo Michelotti
** --- January 26, 1994
**
*/

#include <stdlib.h>
#include "mxyzptlk.rsc"

main( int argc, char** argv ) {

 if( argc != 3 ) {
  printf( "\n" );
  printf( "Usage: %s  d  t                           \n", argv[0] );
  printf( "where  d  = degree of highest derivative  \n" );
  printf( "       t  = upper limit of integration.   \n" );
  printf( "\n" );
  exit(0);
 }

 int    deg   = atoi( argv[1]  );
 double limit = atof( argv[2]  );

 Jet::Setup ( 2, deg, 1 );
 JetC::Setup( 2, deg, 1 );
 coordC x( 0.0 ), t( limit );
 CLieOperator v;
 v.setVariable( x*x, 0 );

 printf( "\n-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-\n" );
 printf( "Upper limit is double variable.\n" );
 v.expMap( limit, x ) .printCoeffs();
 printf( "\n-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-\n" );
 printf( "Upper limit is DA variable.\n" );
 v.expMap( t, x ) .printCoeffs();
 
}
