/*
**
** Demo program:
** 
** --- Leo Michelotti
** --- February 3, 1994
**
*/

#include <stdlib.h>
#include "mxyzptlk.rsc"

main( int argc, char** argv ) {

 if( argc != 3 ) {
  printf( "\n" );
  printf( "Usage: %s  d  t                           \n", argv[0] );
  printf( "where  d  = highest order derivative      \n" );
  printf( "       t  = upper limit of integration.   \n" );
  printf( "\n" );
  exit(0);
 }

 int    deg = atoi( argv[1] );
 double   t = atof( argv[2] );

 Jet::setup( 3, deg, 3 );

 coord  x( 0.0 ),  y( 0.0 ),  z( 0.0 );

 LieOperator u, v;
 Jet r1, r2;

 u.setVariable(  x*x, 0 );
 u.setVariable(  y*y, 1 );
 u.setVariable(  z*z, 2 );

 v.setVariable(  y*z, 0 );
 v.setVariable(  z*x, 1 );
 v.setVariable(  x*y, 2 );

 printf( "\n-*-*-*-  x  coefficients  -*-*-*-*-*\n" );
 r1 = u.expMap( t, v.expMap( t, x ) );
 r2 = v.expMap( t, u.expMap( t, x ) );
 (r1 - r2).printCoeffs();

 printf( "\n-*-*-*-  y  coefficients  -*-*-*-*-*\n" );
 r1 = u.expMap( t, v.expMap( t, y ) );
 r2 = v.expMap( t, u.expMap( t, y ) );
 (r1 - r2).printCoeffs();

 printf( "\n-*-*-*-  z  coefficients  -*-*-*-*-*\n" );
 r1 = u.expMap( t, v.expMap( t, z ) );
 r2 = v.expMap( t, u.expMap( t, z ) );
 (r1 - r2).printCoeffs();

}
