#ifndef ML_HXX
#define ML_HXX

#include <iostream.h>
#include <math.h>
#include <complex.h>

struct MLD {

  double **m;
  int r,c;			// number of rows and columns
  int rc;			// reference count

  // Private member functions_________________________________________

  void clear();
  void error(char * msgl, char * msg2 = " ")const ;
  // Constructors and destructors_____________________________________

  MLD();
  MLD(const MLD&);
  MLD(int rows ,int columns , double initval);
  MLD(int rows, int columns, double* initval);
  ~MLD();

  // Public member functions__________________________________________

 MLD& operator=(const MLD&);
 char operator==(const double&);
 MLD& operator+=(const double&);
 MLD& operator-=(const double&);
friend  char operator==(const MLD&,const MLD&);

};

struct MLC {

  complex **m;
  int r,c;			// number of rows and columns
  int rc;			// reference count

  // Private member functions_________________________________________

  void clear();
  void error(char * msgl, char * msg2 = " ")const ;
  // Constructors and destructors_____________________________________

  MLC();
  MLC(const MLD&);
  MLC(const MLC&);
  MLC(int rows ,int columns , complex initval);
  MLC(int rows, int columns, complex* initval);
  ~MLC();

  // Public member functions__________________________________________

 MLC& operator=(const MLC&);
 char operator==(const complex&);
 MLC& operator+=(const complex&);
 MLC& operator-=(const complex&);
friend  char operator==(const MLC&,const MLC&);

};

struct MLI {

  int **m;
  int r,c;			// number of rows and columns
  int rc;			// reference count

  // Private member functions_________________________________________

  void clear();
  void error(char * msgl, char * msg2 = " ")const ;
  // Constructors and destructors_____________________________________

  MLI();
  MLI(const MLI&);
  MLI(int rows ,int columns , int initval);
  MLI(int rows, int columns, int* initval);
  ~MLI();

  // Public member functions__________________________________________

 MLI& operator=(const MLI&);
 char operator==(const int&);
 MLI& operator+=(const int&);
 MLI& operator-=(const int&);
friend  char operator==(const MLI&,const MLI&);

};

#endif //ML_HXX
